package com.nisum.mongo.controller;

import java.util.List;
import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.nisum.mongo.dal.UserRepository;
import com.nisum.mongo.model.User;
@RestController
@RequestMapping (value = "/")
public class UserController {
	
	private final Logger LOG = LoggerFactory.getLogger(UserController.class.getName());
	
	UserRepository repository ;

	
	public UserController(UserRepository repository) {
		// TODO Auto-generated constructor stub
		this.repository = repository;
	}
	
	@GetMapping(value ="")
	public List<User> getAllUsers(){
		LOG.info("Getting all users");
		return repository.findAll();
		
	}
@GetMapping(value ="/{userId}" )
public Optional<User> getUser(@PathVariable String userId) {
	
	LOG.info("getting user with userId"+ userId);
	return repository.findById(userId);
	
}

@PostMapping(value = "/create")
public User addUser(@RequestBody User user) {
	
	return repository.save(user);
	
}
@GetMapping(value ="/setting/{userId}/{key}")
public String getSetting(@PathVariable String userId,@PathVariable String key) {
	Optional<User> optional = repository.findById(userId);
	if(optional.isPresent()) {
		return optional.get().getUserSettings().get(key);
	}else
		
	return "user Not found";
	
}

@GetMapping(value ="/settings/{userId}/{key}/{value}")
public String addUserSetting(@PathVariable String userId,@PathVariable String key,@PathVariable String value) {
	
	Optional<User> optional = repository.findById(userId);
	if(optional.isPresent()) {
        User user = optional.get();
        user.getUserSettings().put(key, value);
             repository.save(user);
             return "user setting added";

	}else {
		return "User Not found";
	}
			
}

}
