package com.nisum.mongo.controller;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.nisum.mongo.dal.UserDAL;
import com.nisum.mongo.model.User;

@RestController
@RequestMapping (value = "/template")
public class UserTemplateController {

	
		@Autowired
		UserDAL udal;
		
		@GetMapping(value="/")
		List<User> getAllUsers(){
			
			return udal.getAllUsers();
			
		}
		@GetMapping(value="/{userId}")
		User getByUserId(@PathVariable String userId) {
			return udal.getByUserId(userId);
			
		}
		@PostMapping("/create")
		User addNewUser(@RequestBody User user) {
			return udal.addNewUser(user);
			
		}
		@GetMapping("/settings/{userId}")
		Map<String,String> getAllSettingsOfUser(String userId){
			
			return udal.getAllSettingsOfUser(userId);
			
		}
		@GetMapping("/setting/{userId}/{key}")
		String getUserSetting(String userId,String key) {
			return udal.getUserSetting(userId, key);
			
		}
		@GetMapping("/setting/{userId}/{key}/{value}")
		String addUserSetting(String userId, String key, String value) {
			return udal.addUserSetting(userId, key, value);
			
		}
		
	

}
