package com.nisum.mongo.dal;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import com.nisum.mongo.model.User;

@Repository
public class UserDALImpl implements UserDAL {
	
	@Autowired
	MongoTemplate mongoTemplate;

	@Override
	public List<User> getAllUsers() {
		return mongoTemplate.findAll(User.class);
	}

	@Override
	public User getByUserId(String userId) {
		return mongoTemplate.findById(userId, User.class);
	}

	@Override
	public User addNewUser(User user) {
		return mongoTemplate.save(user);
	}

	@Override
	public Map<String, String> getAllSettingsOfUser(String userId) {
		Query query = new Query();
		query.addCriteria(Criteria.where(userId));
		User user = mongoTemplate.findOne(query, User.class);
	
		return user !=null ?user.getUserSettings():new HashMap<String,String>();
	}

	@Override
	public String getUserSetting(String userId, String key) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String addUserSetting(String userId, String key, String value) {
		// TODO Auto-generated method stub
		return null;
	}

}
